// ----------------------------------------------------------------------
// Overview
//   String display window
// ----------------------------------------------------------------------
#ifndef __TXT_WINDOW__
#define __TXT_WINDOW__

#include "CtrlGraphics.h"

// ----------------------------------------------------------------------
// String information
// ----------------------------------------------------------------------
typedef struct
{
	char str[128];
	GLfloat r;
	GLfloat g;
	GLfloat b;
}STR_INFO, *LPSTR_INFO;

// ----------------------------------------------------------------------
// String render window
// ----------------------------------------------------------------------
class CTxtWindow
{
public:
	CTxtWindow(char* title);
	~CTxtWindow();
	
	void		SetText			(int line, char* str, GLfloat r, GLfloat g, GLfloat b);
	void		SetLines		(int line);
	void		DrawWindow		(CCtrlGraphics* graphics, const s32 display, int sx, int sy);

	void		SetWindowWidth	(int width);
	void		SetWindowHeight	(int height);

	void		SetForcus		(bool bForcus);

private:
	s32			m_bForcus;		// Window Focus
	char		m_title[64];	// Window Title
	u32			m_line;		
	STR_INFO*	m_info;

	u32			m_width;
	u32			m_height;
};

#endif // __TXT_WINDOW__
